start test2

long seed = 1;
long mulconst = 0x015a4e35;
long maskconst = 0x7fff;
long numwithocc;

main
{
reg long t;
reg long *avp;
reg long tablelongs;
reg long count;
reg char *array;
reg long i;

avp = argv;

if ( argc != 2 )
{
   printf("Usage: run <seed> <num_entries>\n");
   exit(1);
}

set t = strtoul(avp[0],0,0);
seed = t;
set count = strtoul(avp[1],0,0);
set array = malloc(32768);

for (i=0 ;i<32768 ;i++)
{
    array[i] = 0;
}

for (i=0;i<count;i++)
{
  set t = myrand();
//printf("i=%d t=%d\n",i,t);
  array[t] = array[t] + 1;
}

for ( t = 1; t < 8 ; t++ )
{
  numwithocc = 0;
  for (i=0;i<32768;i++)
  {
    if ( array[i] == t )
    {
       numwithocc = numwithocc + 1;
    }
  }
  printf("occ=%2d  num=%9d\n",t,numwithocc);
}
free(array);
printf("done\n");
}

subroutine myrand
{
    reg long temp;

//printf("  seed=0x%08x\n",seed);
//printf("  mulconst=0x%08x\n",mulconst);
    seed = seed * mulconst;
//printf("  * seed=0x%08x\n",seed);
    seed = seed + 1;
//printf("  +1 seed=0x%08x\n",seed);
    temp = seed;
//printf("  => temp=0x%08x\n",temp);
    temp >> 16;
//printf("  temp=0x%08x\n",temp);
    temp = temp & maskconst;
//printf("  temp=0x%08x\n",temp);
    return( temp );
}
end
